selftest/bpf/benchs: Add bpf_map benchmark
authorFeng Zhou <zhoufeng.zf@bytedance.com>
Fri, 10 Jun 2022 02:33:08 +0000 (10:33 +0800)
committerAlexei Starovoitov <ast@kernel.org>
Sat, 11 Jun 2022 21:25:35 +0000 (14:25 -0700)
Add benchmark for hash_map to reproduce the worst case
that non-stop update when map's free is zero.

Just like this:
./run_bench_bpf_hashmap_full_update.sh
Setting up benchmark 'bpf-hashmap-ful-update'...
Benchmark 'bpf-hashmap-ful-update' started.
1:hash_map_full_perf 555830 events per sec
...

Signed-off-by: Feng Zhou <zhoufeng.zf@bytedance.com>
Link: https://lore.kernel.org/r/20220610023308.93798-3-zhoufeng.zf@bytedance.com
Signed-off-by: Alexei Starovoitov <ast@kernel.org>
tools/testing/selftests/bpf/Makefile
tools/testing/selftests/bpf/bench.c
tools/testing/selftests/bpf/benchs/bench_bpf_hashmap_full_update.c [new file with mode: 0644]
tools/testing/selftests/bpf/benchs/run_bench_bpf_hashmap_full_update.sh [new file with mode: 0755]
tools/testing/selftests/bpf/progs/bpf_hashmap_full_update_bench.c [new file with mode: 0644]

index 2d3c8c8f558a8ee16c114cc6c29f9c15cf5d6cfd..8ad7a733a5055d56ce353882bb29c4a7cc741ffb 100644 (file)
@@ -560,6 +560,7 @@ $(OUTPUT)/bench_ringbufs.o: $(OUTPUT)/ringbuf_bench.skel.h \
 $(OUTPUT)/bench_bloom_filter_map.o: $(OUTPUT)/bloom_filter_bench.skel.h
 $(OUTPUT)/bench_bpf_loop.o: $(OUTPUT)/bpf_loop_bench.skel.h
 $(OUTPUT)/bench_strncmp.o: $(OUTPUT)/strncmp_bench.skel.h
+$(OUTPUT)/bench_bpf_hashmap_full_update.o: $(OUTPUT)/bpf_hashmap_full_update_bench.skel.h
 $(OUTPUT)/bench.o: bench.h testing_helpers.h $(BPFOBJ)
 $(OUTPUT)/bench: LDLIBS += -lm
 $(OUTPUT)/bench: $(OUTPUT)/bench.o \
@@ -571,7 +572,8 @@ $(OUTPUT)/bench: $(OUTPUT)/bench.o \
                 $(OUTPUT)/bench_ringbufs.o \
                 $(OUTPUT)/bench_bloom_filter_map.o \
                 $(OUTPUT)/bench_bpf_loop.o \
-                $(OUTPUT)/bench_strncmp.o
+                $(OUTPUT)/bench_strncmp.o \
+                $(OUTPUT)/bench_bpf_hashmap_full_update.o
        $(call msg,BINARY,,$@)
        $(Q)$(CC) $(CFLAGS) $(LDFLAGS) $(filter %.a %.o,$^) $(LDLIBS) -o $@
 
index f061cc20e77638bb948f2e040856e2c687360274..d8aa62be996bdfc1f00779a11f83730e160c5021 100644 (file)
@@ -396,6 +396,7 @@ extern const struct bench bench_hashmap_with_bloom;
 extern const struct bench bench_bpf_loop;
 extern const struct bench bench_strncmp_no_helper;
 extern const struct bench bench_strncmp_helper;
+extern const struct bench bench_bpf_hashmap_full_update;
 
 static const struct bench *benchs[] = {
        &bench_count_global,
@@ -430,6 +431,7 @@ static const struct bench *benchs[] = {
        &bench_bpf_loop,
        &bench_strncmp_no_helper,
        &bench_strncmp_helper,
+       &bench_bpf_hashmap_full_update,
 };
 
 static void setup_benchmark()
diff --git a/tools/testing/selftests/bpf/benchs/bench_bpf_hashmap_full_update.c b/tools/testing/selftests/bpf/benchs/bench_bpf_hashmap_full_update.c
new file mode 100644 (file)
index 0000000..cec51e0
--- /dev/null
@@ -0,0 +1,96 @@
+// SPDX-License-Identifier: GPL-2.0
+/* Copyright (c) 2022 Bytedance */
+
+#include <argp.h>
+#include "bench.h"
+#include "bpf_hashmap_full_update_bench.skel.h"
+#include "bpf_util.h"
+
+/* BPF triggering benchmarks */
+static struct ctx {
+       struct bpf_hashmap_full_update_bench *skel;
+} ctx;
+
+#define MAX_LOOP_NUM 10000
+
+static void validate(void)
+{
+       if (env.consumer_cnt != 1) {
+               fprintf(stderr, "benchmark doesn't support multi-consumer!\n");
+               exit(1);
+       }
+}
+
+static void *producer(void *input)
+{
+       while (true) {
+               /* trigger the bpf program */
+               syscall(__NR_getpgid);
+       }
+
+       return NULL;
+}
+
+static void *consumer(void *input)
+{
+       return NULL;
+}
+
+static void measure(struct bench_res *res)
+{
+}
+
+static void setup(void)
+{
+       struct bpf_link *link;
+       int map_fd, i, max_entries;
+
+       setup_libbpf();
+
+       ctx.skel = bpf_hashmap_full_update_bench__open_and_load();
+       if (!ctx.skel) {
+               fprintf(stderr, "failed to open skeleton\n");
+               exit(1);
+       }
+
+       ctx.skel->bss->nr_loops = MAX_LOOP_NUM;
+
+       link = bpf_program__attach(ctx.skel->progs.benchmark);
+       if (!link) {
+               fprintf(stderr, "failed to attach program!\n");
+               exit(1);
+       }
+
+       /* fill hash_map */
+       map_fd = bpf_map__fd(ctx.skel->maps.hash_map_bench);
+       max_entries = bpf_map__max_entries(ctx.skel->maps.hash_map_bench);
+       for (i = 0; i < max_entries; i++)
+               bpf_map_update_elem(map_fd, &i, &i, BPF_ANY);
+}
+
+void hashmap_report_final(struct bench_res res[], int res_cnt)
+{
+       unsigned int nr_cpus = bpf_num_possible_cpus();
+       int i;
+
+       for (i = 0; i < nr_cpus; i++) {
+               u64 time = ctx.skel->bss->percpu_time[i];
+
+               if (!time)
+                       continue;
+
+               printf("%d:hash_map_full_perf %lld events per sec\n",
+                      i, ctx.skel->bss->nr_loops * 1000000000ll / time);
+       }
+}
+
+const struct bench bench_bpf_hashmap_full_update = {
+       .name = "bpf-hashmap-ful-update",
+       .validate = validate,
+       .setup = setup,
+       .producer_thread = producer,
+       .consumer_thread = consumer,
+       .measure = measure,
+       .report_progress = NULL,
+       .report_final = hashmap_report_final,
+};
diff --git a/tools/testing/selftests/bpf/benchs/run_bench_bpf_hashmap_full_update.sh b/tools/testing/selftests/bpf/benchs/run_bench_bpf_hashmap_full_update.sh
new file mode 100755 (executable)
index 0000000..1e2de83
--- /dev/null
@@ -0,0 +1,11 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+
+source ./benchs/run_common.sh
+
+set -eufo pipefail
+
+nr_threads=`expr $(cat /proc/cpuinfo | grep "processor"| wc -l) - 1`
+summary=$($RUN_BENCH -p $nr_threads bpf-hashmap-ful-update)
+printf "$summary"
+printf "\n"
diff --git a/tools/testing/selftests/bpf/progs/bpf_hashmap_full_update_bench.c b/tools/testing/selftests/bpf/progs/bpf_hashmap_full_update_bench.c
new file mode 100644 (file)
index 0000000..5695755
--- /dev/null
@@ -0,0 +1,40 @@
+// SPDX-License-Identifier: GPL-2.0
+/* Copyright (c) 2022 Bytedance */
+
+#include "vmlinux.h"
+#include <bpf/bpf_helpers.h>
+#include "bpf_misc.h"
+
+char _license[] SEC("license") = "GPL";
+
+#define MAX_ENTRIES 1000
+
+struct {
+       __uint(type, BPF_MAP_TYPE_HASH);
+       __type(key, u32);
+       __type(value, u64);
+       __uint(max_entries, MAX_ENTRIES);
+} hash_map_bench SEC(".maps");
+
+u64 __attribute__((__aligned__(256))) percpu_time[256];
+u64 nr_loops;
+
+static int loop_update_callback(__u32 index, u32 *key)
+{
+       u64 init_val = 1;
+
+       bpf_map_update_elem(&hash_map_bench, key, &init_val, BPF_ANY);
+       return 0;
+}
+
+SEC("fentry/" SYS_PREFIX "sys_getpgid")
+int benchmark(void *ctx)
+{
+       u32 cpu = bpf_get_smp_processor_id();
+       u32 key = cpu + MAX_ENTRIES;
+       u64 start_time = bpf_ktime_get_ns();
+
+       bpf_loop(nr_loops, loop_update_callback, &key, 0);
+       percpu_time[cpu & 255] = bpf_ktime_get_ns() - start_time;
+       return 0;
+}